/*
 * Get or ask for the value of a variable.
 * Get local IP#, Remote IP# and MTU
 */

#define VAR_IP          1
#define VAR_NUM         2
#define VAR_STR         3

char *grab_remote(int var)
    {
    char c, *p;
    int state, timeout, result;

    static char str[128];

    p = str;
    timeout = 0;
    state = 0;

    if (var == VAR_IP || var == VAR_NUM)
        state = 1;

    while ((p < &str[sizeof(str) - 1]) && (state >= 0))
        {
        result = get_char();

        if (result == -1)
            {
            timeout = 1;
            break;
            }

        c = (char)result;
        c &= 0177;

        switch (state)
            {
            case 0: /* throw away "white space" */
                if (! strchr(" \n\t", c))
                    break;

                if (var == VAR_STR)
                    {
                    *(p++) = c;
                    state = 10;
                    break;
                    }
                state = 1;
            /* fall thru */

            case 1:
                if ( c >= '0' && c <= '9' )
                    {
                    *(p++) = c;

                    if (var == VAR_IP)
                        {
                        state = 2;
                        break;
                        }
                    else
                        state = 5;

                    break;
                    }
            break;

            case 2:
            case 3:
            case 4:
                if ((c >= '0' && c <= '9') || c == '.')
                    {
                    *(p++) = c;

                    if (c == '.')
                        state++;

                    break;
                    }

                p = str;
                state = 0;
            break;

            case 5:
                if (c >= '0' && c <= '9')
                    {
                    *(p++) = c;
                    break;
                    }

                state = -1;
            break;

            case 10:
                if (strchr(" \n\t", c))
                    state = -1;
                else
                    *(p++) = c;
            break;

            default:
            break;
            }
        }

    *p = '\0';

    if (timeout == 1)
        return ((char *)0);

    return (str);
    }

