#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>

#define _USEPATH 1
#define _PROGRAM 2
#define _STRING  4

int _spawn(char *pathP, char *cmdP, char *envP);
char * pascal __searchpath(char *pathP, int mode);

int main(void)
{
    char *progpath, *comspec, *cmdline;
#ifdef COMMANDCOM
    char *command = "/C SET";
#else	/* COMMANDCOM */
    char *command = "-v -f chatscr";
#endif	/* COMMANDCOM */
    int rc;

#ifdef COMMANDCOM
    if ( (comspec = getenv("COMSPEC")) == NULL ) {
	fprintf(stderr, "Couldn't locate COMMAND.COM\n");
	return 1;
    }

    if ( (progpath = strdup(comspec)) == NULL ) {
	fprintf(stderr, "Out of memory\n");
	return 2;
    }
#else	/* COMMANDCOM */
    if ( (comspec = __searchpath("chat", _USEPATH | _PROGRAM)) == NULL ) {
	fprintf(stderr, "Couldn't locate %s\n", "chat");
	return 1;
    }

    if ( (progpath = strdup(comspec)) == NULL ) {
	fprintf(stderr, "Out of memory\n");
	return 2;
    }
#endif	/* COMMANDCOM */

    if ( (cmdline = (char *)malloc(256)) == NULL ) {
	fprintf(stderr, "Out of memory\n");
	return 3;
    }

    cmdline[0] = strlen(command);
    strcpy(&cmdline[1], command);
    strcat(&cmdline[1], "\r");

    rc = _spawn(progpath, cmdline, (char *)0);

    if ( rc < 0 ) {
	perror("_spawn() call failed");
	return 4;
    }

    fprintf(stderr, "Child returned %u\n", (unsigned)(char)rc);

    return 0;
}

