


PPPD(8)                                                   PPPD(8)


NAME
       pppd - Point to Point Protocol daemon

SYNOPSIS
       pppd [ tty name ] [ speed ] [ options ]

DESCRIPTION
       The  Point-to-Point  Protocol  (PPP) provides a method for
       transmitting datagrams over serial  point-to-point  links.
       PPP is composed of three parts: a method for encapsulating
       datagrams over serial links, an  extensible  Link  Control
       Protocol  (LCP), and a family of Network Control Protocols
       (NCP) for establishing and configuring different  network-
       layer protocols.

       The encapsulation scheme is provided by driver code in the
       kernel.  pppd provides the basic LCP, authentication  sup-
       port,  and  an  NCP  for  establishing and configuring the
       Internet Protocol (IP) (called the  IP  Control  Protocol,
       IPCP).

FREQUENTLY USED OPTIONS
       <tty name>
              Communicate  over  the  named  device.   The string
              "/dev/" is prepended if necessary.   If  no  device
              name  is  given,  or if the name of the controlling
              terminal is given, pppd will  use  the  controlling
              terminal,  and  will  not fork to put itself in the
              background.

       <speed>
              Set the baud rate to <speed>  (a  decimal  number).
              On systems such as 4.4BSD and NetBSD, any speed can
              be specified.  Other  systems  (e.g.  SunOS)  allow
              only a limited set of speeds.

       asyncmap <map>
              Set  the  async  character  map to <map>.  This map
              describes which control characters cannot  be  suc-
              cessfully received over the serial line.  pppd will
              ask the peer to send these characters as  a  2-byte
              escape sequence.  The argument is a 32 bit hex num-
              ber with  each  bit  representing  a  character  to
              escape.   Bit 0 (00000001) represents the character
              0x00; bit 31 (80000000)  represents  the  character
              0x1f  or  ^ .   If  multiple  asyncmap  options are
              given,  the  values  are  ORed  together.   If   no
              asyncmap  option  is  given, no async character map
              will be negotiated for the receive  direction;  the
              peer should then escape all control characters.

       auth   Require  the  peer  to  authenticate  itself before
              allowing network packets to be sent or received.




                                                                1





PPPD(8)                                                   PPPD(8)


       connect <p>
              Use the executable or shell  command  specified  by
              <p>  to  set up the serial line.  This script would
              typically use the chat(8) program to dial the modem
              and start the remote ppp session.

       crtscts
              Use hardware flow control (i.e. RTS/CTS) to control
              the flow of data on the serial  port.   If  neither
              the  crtscts  nor the -crtscts option is given, the
              hardware flow control setting for the  serial  port
              is left unchanged.

       defaultroute
              Add  a  default route to the system routing tables,
              using the peer as the gateway, when  IPCP  negotia-
              tion  is  successfully  completed.   This  entry is
              removed when the PPP connection is broken.

       disconnect <p>
              Run the executable or shell  command  specified  by
              <p>  after  pppd  has  terminated  the  link.  This
              script could, for example, issue  commands  to  the
              modem to cause it to hang up if hardware modem con-
              trol signals were not available.

       escape xx,yy,...
              Specifies that certain characters should be escaped
              on  transmission  (regardless  of  whether the peer
              requests them to be escaped with its async  control
              character  map).   The characters to be escaped are
              specified as a list of  hex  numbers  separated  by
              commas.   Note  that  almost  any  character can be
              specified  for  the  escape  option,   unlike   the
              asyncmap  option  which only allows control charac-
              ters to be specified.  The characters which may not
              be escaped are those with hex values 0x20 - 0x3f or
              0x5e.

       file <f>
              Read options from file <f> (the format is described
              below).

       lock   Specifies that pppd should create a UUCP-style lock
              file for the  serial  device  to  ensure  exclusive
              access to the device.

       mru <n>
              Set the MRU [Maximum Receive Unit] value to <n> for
              negotiation.  pppd will ask the peer to send  pack-
              ets  of  no  more  than <n> bytes.  The minimum MRU
              value is 128.  The default MRU value  is  1500.   A
              value  of  296  is  recommended  for slow links (40
              bytes for TCP/IP header + 256 bytes of data).



                                                                2





PPPD(8)                                                   PPPD(8)


       mtu <n>
              Set the MTU [Maximum Transmit Unit] value  to  <n>.
              Unless  the  peer  requests a smaller value via MRU
              negotiation, pppd will request that the kernel net-
              working  code  send  data packets of no more than n
              bytes through the PPP network interface.

       netmask <n>
              Set the interface netmask to <n>, a 32 bit  netmask
              in "decimal dot" notation (e.g. 255.255.255.0).  If
              this option is given, the value specified  is  ORed
              with  the  default netmask.  The default netmask is
              chosen based on the negotiated remote  IP  address;
              it is the appropriate network mask for the class of
              the remote IP address, ORed with the  netmasks  for
              any  non  point-to-point  network interfaces in the
              system which are on the same network.

       passive
              Enables the "passive" option in the LCP.  With this
              option, pppd will attempt to initiate a connection;
              if no reply is received from the  peer,  pppd  will
              then  just  wait  passively  for a valid LCP packet
              from the peer (instead of exiting, as it does with-
              out this option).

       silent With  this option, pppd will not transmit LCP pack-
              ets to initiate a  connection  until  a  valid  LCP
              packet  is received from the peer (as for the `pas-
              sive' option with ancient versions of pppd).

OPTIONS
       <local IP address>:<remote IP address>
              Set the local and/or remote interface IP addresses.
              Either one may be omitted.  The IP addresses can be
              specified with a host name or in decimal dot  nota-
              tion   (e.g.  150.234.56.78).   The  default  local
              address is the (first) IP  address  of  the  system
              (unless  the  noipdefault  option  is  given).  The
              remote address will be obtained from  the  peer  if
              not  specified  in  any  option.   Thus,  in simple
              cases, this option is not  required.   If  a  local
              and/or  remote  IP  address  is specified with this
              option, pppd will not accept a different value from
              the  peer in the IPCP negotiation, unless the ipcp-
              accept-local and/or ipcp-accept-remote options  are
              given, respectively.

       -ac    Disable   Address/Control  compression  negotiation
              (use default, i.e.  address/control field  compres-
              sion disabled).

       -all   Don't  request  or allow negotiation of any options
              for LCP and IPCP (use default values).



                                                                3





PPPD(8)                                                   PPPD(8)


       -am    Disable  asyncmap  negotiation  (use  the   default
              asyncmap, i.e. escape all control characters).

       -as <n>
              Same as asyncmap <n>

       bsdcomp nr,nt
              Request  that  the  peer  compress  packets that it
              sends, using the BSD-Compress scheme, with a  maxi-
              mum  code  size  of  nr bits, and agree to compress
              packets sent to the peer with a maximum  code  size
              of nt bits.  If nt is not specified, it defaults to
              the value given for nr.  Values in the range  9  to
              15  may  be  used for nr and nt; larger values give
              better compression but consume more  kernel  memory
              for  compression  dictionaries.   Alternatively,  a
              value of 0 for nr or nt disables compression in the
              corresponding direction.

       -bsdcomp
              Disables  compression;  pppd  will  not  request or
              agree to compress packets  using  the  BSD-Compress
              scheme.

       +chap  Require  the peer to authenticate itself using CHAP
              [Cryptographic Handshake  Authentication  Protocol]
              authentication.

       -chap  Don't agree to authenticate using CHAP.

       chap-interval <n>
              If  this option is given, pppd will rechallenge the
              peer every <n> seconds.

       chap-max-challenge <n>
              Set the maximum number of CHAP challenge  transmis-
              sions to <n> (default 10).

       chap-restart <n>
              Set the CHAP restart interval (retransmission time-
              out for challenges) to <n> seconds (default 3).

       -crtscts
              Disable hardware flow control (i.e. RTS/CTS) on the
              serial  port.   If  neither  the  crtscts  nor  the
              -crtscts option is given, the hardware flow control
              setting for the serial port is left unchanged.

       -d     Increase   debugging   level  (same  as  the  debug
              option).

       debug  Increase debugging level (same  as  -d).   If  this
              option  is given, pppd will log the contents of all
              control packets sent  or  received  in  a  readable



                                                                4





PPPD(8)                                                   PPPD(8)


              form.   The  packets are logged through syslog with
              facility daemon and level debug.  This  information
              can   be   directed   to   a  file  by  setting  up
              /etc/syslog.conf    appropriately     (see     sys-
              log.conf(5)).

       -defaultroute
              Disable the defaultroute option.  The system admin-
              istrator who wishes to prevent users from  creating
              default  routes with pppd can do so by placing this
              option in the /etc/ppp/options file.

       -detach
              Don't fork to become a background  process  (other-
              wise  pppd will do so if a serial device other than
              its controlling terminal is specified).

       dns-addr <n>
              This option sets the IP address  or  addresses  for
              the  Domain  Name  Server.  It is used by Microsoft
              Windows clients. The primary DNS address is  speci-
              fied  by the first instance of the dns-addr option.
              The secondary is specified by the second  instance.

       domain <d>
              Append  the  domain name <d> to the local host name
              for authentication purposes.  For example, if geth-
              ostname()  returns  the name porsche, but the fully
              qualified domain name is  porsche.Quotron.COM,  you
              would  use the domain option to set the domain name
              to Quotron.COM.

       -ip    Disable IP address negotiation.  If this option  is
              used,  the remote IP address must be specified with
              an option on the command  line  or  in  an  options
              file.

       +ip-protocol
              Enable  the  IPCP  and  IP  protocols.  This is the
              default condition. This option is  only  needed  if
              the default setting is -ip-protocol.

       -ip-protocol
              Disable the IPCP and IP protocols. This should only
              be used if you know that you  are  using  a  client
              which  only  understands  IPX and you don't want to
              confuse the client with the IPCP protocol.

       +ipx-protocol
              Enable the IPXCP and IPX  protocols.  This  is  the
              default condition if your kernel supports IPX. This
              option is only needed if  the  default  setting  is
              -ipx-protocol.  If your kernel does not support IPX
              then this option will have no effect.



                                                                5





PPPD(8)                                                   PPPD(8)


       -ipx-protocol
              Disable the IPXCP and IPX  protocols.  This  should
              only  be  used  if  you  know  that you are using a
              client which only understands IP and you don't want
              to confuse the client with the IPXCP protocol.

       ipcp-accept-local
              With  this option, pppd will accept the peer's idea
              of our local IP  address,  even  if  the  local  IP
              address was specified in an option.

       ipcp-accept-remote
              With  this option, pppd will accept the peer's idea
              of its (remote) IP address, even if the  remote  IP
              address was specified in an option.

       ipcp-max-configure <n>
              Set  the  maximum  number of IPCP configure-request
              transmissions to <n> (default 10).

       ipcp-max-failure <n>
              Set  the  maximum  number  of  IPCP  configure-NAKs
              returned  before starting to send configure-Rejects
              instead to <n> (default 10).

       ipcp-max-terminate <n>
              Set the maximum number  of  IPCP  terminate-request
              transmissions to <n> (default 3).

       ipcp-restart <n>
              Set the IPCP restart interval (retransmission time-
              out) to <n> seconds (default 3).

       ipparam string
              Provides an extra parameter to the  ip-up  and  ip-
              down  scripts.  If this option is given, the string
              supplied is given as the  6th  parameter  to  those
              scripts.

       ipx-network <n>
              Set  the  IPX network number in the IPXCP configure
              request frame to <n>. There is no valid default. If
              this  option is not specified then the network num-
              ber is obtained from the peer. If the peer does not
              have  the network number, the IPX protocol will not
              be started. This is a  hexadecimal  number  and  is
              entered without any leading sequence such as 0x. It
              is related to the ipxcp-accept-network option.

       ipx-node <n>:<m>
              Set the IPX node numbers. The two node numbers  are
              separated  from  each other with a colon character.
              The first number <n> is the local node number.  The
              second  number  <m> is the peer's node number. Each



                                                                6





PPPD(8)                                                   PPPD(8)


              node number is a hexadecimal number, to the maximum
              of  ten significant digits. The node numbers on the
              ipx-network must  be  unique.  There  is  no  valid
              default.  If  this option is not specified then the
              node number is obtained from the peer. This  option
              is  a  related to the ipxcp-accept-local and ipxcp-
              accept-remote options.

       ipx-router-name <string>
              Set the name of the router. This is a string and is
              sent to the peer as information data.

       ipx-routing <n>
              Set  the  routing  protocol  to be received by this
              option. More than one instance of  ipx-routing  may
              be  specified.  The 'none' option (0) may be speci-
              fied as the only instance of ipx-routing. The  val-
              ues  may  be  0  for NONE, 2 for RIP/SAP, and 4 for
              NLSP.

       ipxcp-accept-local
              Accept the peer's NAK for the node number specified
              in the ipx-node option. If a node number was speci-
              fied, and non-zero, the default is to  insist  that
              the  value be used. If you include this option then
              you will permit the peer to override the  entry  of
              the node number.

       ipxcp-accept-network
              Accept the peer's NAK for the network number speci-
              fied in the ipx-network option. If a network number
              was  specified,  and  non-zero,  the  default is to
              insist that the value be used. If you include  this
              option  then  you  will permit the peer to override
              the entry of the node number.

       ipxcp-accept-remote
              Use the peer's network number specified in the con-
              figure  request  frame. If a node number was speci-
              fied for the peer and this option  was  not  speci-
              fied,  the  peer  will  be  forced to use the value
              which you have specified.

       ipxcp-max-configure <n>
              Set the maximum number of IPXCP  configure  request
              frames  which  the  system  will  send  to <n>. The
              default is 10.

       ipxcp-max-failure <n>
              Set the maximum number of IPXCP  NAK  frames  which
              the  local  system  will send before it rejects the
              options. The default value is 3.





                                                                7





PPPD(8)                                                   PPPD(8)


       ipxcp-max-terminate <n>
              Set the maximum nuber of  IPXCP  terminate  request
              frames  before  the local system considers that the
              peer is not listening to them. The default value is
              3.

       kdebug n
              Enable  debugging  code  in  the  kernel-level  PPP
              driver.  The argument n is a number  which  is  the
              sum  of  the  following values: 1 to enable general
              debug messages, 2 to request that the  contents  of
              received  packets be printed, and 4 to request that
              the contents of transmitted packets be printed.

       lcp-echo-failure <n>
              If this option is given, pppd will presume the peer
              to  be dead if n LCP echo-requests are sent without
              receiving a valid LCP echo-reply.  If this happens,
              pppd  will  terminate  the connection.  Use of this
              option requires a non-zero value for the  lcp-echo-
              interval  parameter.   This  option  can be used to
              enable pppd to terminate after the physical connec-
              tion  has been broken (e.g., the modem has hung up)
              in situations where no hardware modem control lines
              are available.

       lcp-echo-interval <n>
              If  this  option  is  given,  pppd will send an LCP
              echo-request frame to the  peer  every  n  seconds.
              Under Linux, the echo-request is sent when no pack-
              ets have been received from the peer for n seconds.
              Normally  the  peer  should  respond  to  the echo-
              request by sending an echo-reply.  This option  can
              be  used with the lcp-echo-failure option to detect
              that the peer is no longer connected.

       lcp-max-configure <n>
              Set the maximum  number  of  LCP  configure-request
              transmissions to <n> (default 10).

       lcp-max-failure <n>
              Set   the  maximum  number  of  LCP  configure-NAKs
              returned before starting to send  configure-Rejects
              instead to <n> (default 10).

       lcp-max-terminate <n>
              Set  the  maximum  number  of LCP terminate-request
              transmissions to <n> (default 3).

       lcp-restart <n>
              Set the LCP restart interval (retransmission  time-
              out) to <n> seconds (default 3).

       local  Don't  use  the  modem  control  lines.   With this



                                                                8





PPPD(8)                                                   PPPD(8)


              option, pppd will ignore the state of the CD  (Car-
              rier  Detect)  signal  from  the modem and will not
              change the state of the DTR (Data  Terminal  Ready)
              signal.

       login  Use the system password database for authenticating
              the peer using PAP, and record the user in the sys-
              tem wtmp file.

       modem  Use  the  modem  control lines.  This option is the
              default.  With this option, pppd will wait for  the
              CD  (Carrier  Detect)  signal  from the modem to be
              asserted when opening the serial device  (unless  a
              connect  script is specified), and it will drop the
              DTR (Data Terminal Ready) signal briefly  when  the
              connection  is  terminated and before executing the
              connect script.  On  Ultrix,  this  option  implies
              hardware flow control, as for the crtscts option.

       -mn    Disable   magic   number  negotiation.   With  this
              option, pppd cannot detect a looped-back line.

       -mru   Disable MRU  [Maximum  Receive  Unit]  negotiation.
              With  this  option,  pppd  will use the default MRU
              value of 1500 bytes.

       name <n>
              Set the name of the local system for authentication
              purposes to <n>.

       noipdefault
              Disables  the  default  behaviour  when no local IP
              address is specified, which  is  to  determine  (if
              possible)  the  local IP address from the hostname.
              With this option, the peer will have to supply  the
              local IP address during IPCP negotiation (unless it
              specified explicitly on the command line or  in  an
              options file).

       -p     Same as the passive option.

       +pap   Require  the peer to authenticate itself using PAP.

       -pap   Don't agree to authenticate using PAP.

       papcrypt
              Indicates that all  secrets  in  the  /etc/ppp/pap-
              secrets  file which are used for checking the iden-
              tity of the  peer  are  encrypted,  and  thus  pppd
              should  not accept a password which (before encryp-
              tion)  is  identical  to  the   secret   from   the
              /etc/ppp/pap-secrets file.





                                                                9





PPPD(8)                                                   PPPD(8)


       pap-max-authreq <n>
              Set  the maximum number of PAP authenticate-request
              transmissions to <n> (default 10).

       pap-restart <n>
              Set the PAP restart interval (retransmission  time-
              out) to <n> seconds (default 3).

       pap-timeout <n>
              Set  the  maximum  time that pppd will wait for the
              peer to authenticate itself with PAP to <n> seconds
              (0 means no limit).

       -pc    Disable protocol field compression negotiation (use
              default,  i.e.   protocol  field  compression  dis-
              abled).

       persist
              Do  not  exit  after  a  connection  is terminated;
              instead try to reopen the connection.

       pred1comp
              Attempt to request that the  peer  send  the  local
              system  frames  which  have  been compressed by the
              Predictor-1 compression. The compression  protocols
              must be loaded or this option will be ignored.

       -pred1comp
              Do  not  accept Predictor-1 comprssion, even if the
              peer wants to send this  type  of  compression  and
              support has been defined in the kernel.

       proxyarp
              Add  an entry to this system's ARP [Address Resolu-
              tion Protocol] table with the  IP  address  of  the
              peer and the Ethernet address of this system.

       -proxyarp
              Disable  the  proxyarp option.  The system adminis-
              trator who wishes to prevent  users  from  creating
              proxy  ARP  entries  with pppd can do so by placing
              this option in the /etc/ppp/options file.

       remotename <n>
              Set the assumed  name  of  the  remote  system  for
              authentication purposes to <n>.

       +ua <p>
              Agree to authenticate using PAP [Password Authenti-
              cation Protocol] if requested by the peer, and  use
              the  data  in file <p> for the user and password to
              send to the peer. The file contains the remote user
              name, followed by a newline, followed by the remote
              password, followed by a newline.   This  option  is



                                                               10





PPPD(8)                                                   PPPD(8)


              obsolescent.

       usehostname
              Enforce  the use of the hostname as the name of the
              local system for authentication purposes (overrides
              the name option).

       user <u>
              Set  the  user  name to use for authenticating this
              machine with the peer using PAP to <u>.

       -vj    Disable negotiation of Van  Jacobson  style  TCP/IP
              header  compression  (use default, i.e. no compres-
              sion).

       -vjccomp
              Disable the connection-ID compression option in Van
              Jacobson  style  TCP/IP  header  compression.  With
              this option, pppd will not omit  the  connection-ID
              byte  from  Van Jacobson compressed TCP/IP headers,
              nor ask the peer to do so.

       vj-max-slots n
              Sets the number of connection slots to be  used  by
              the  Van  Jacobson  TCP/IP  header  compression and
              decompression code to n, which must  be  between  2
              and 16 (inclusive).

       xonxoff
              Use  software  flow control (i.e. XON/XOFF) to con-
              trol the flow of data on  the  serial  port.   This
              option is only implemented on Linux systems at pre-
              sent.

OPTIONS FILES
       Options can be taken from files as  well  as  the  command
       line.   pppd reads options from the files /etc/ppp/options
       and ~/.ppprc before  looking  at  the  command  line.   An
       options  file  is parsed into a series of words, delimited
       by whitespace.  Whitespace can be included in  a  word  by
       enclosing  the word in quotes (").  A backslash (\) quotes
       the following character.  A hash  (#)  starts  a  comment,
       which continues until the end of the line.

AUTHENTICATION
       pppd provides system administrators with sufficient access
       control that PPP access to a server machine  can  be  pro-
       vided to legitimate users without fear of compromising the
       security of the server or the network it's  on.   In  part
       this  is  provided by the /etc/ppp/options file, where the
       administrator can place options to require  authentication
       whenever  pppd  is  run,  and  in part by the PAP and CHAP
       secrets files, where the administrator  can  restrict  the
       set of IP addresses which individual users may use.



                                                               11





PPPD(8)                                                   PPPD(8)


       The  default behaviour of pppd is to agree to authenticate
       if requested, and to not require authentication  from  the
       peer.  However, pppd will not agree to authenticate itself
       with a particular protocol if  it  has  no  secrets  which
       could be used to do so.

       Authentication  is  based  on  secrets, which are selected
       from  secrets   files   (/etc/ppp/pap-secrets   for   PAP,
       /etc/ppp/chap-secrets  for CHAP).  Both secrets files have
       the same format, and both can store  secrets  for  several
       combinations  of  server  (authenticating peer) and client
       (peer being authenticated).  Note that pppd can be both  a
       server  and  client,  and  that different protocols can be
       used in the two directions if desired.

       A secrets file is parsed into words as for a options file.
       A  secret  is  specified  by  a line containing at least 3
       words, in the order client name, server name, secret.  Any
       following words on the same line are taken to be a list of
       acceptable IP addresses for that  client.   If  there  are
       only  3  words  on  the  line,  it  is assumed that any IP
       address is OK; to disallow all IP addresses, use "-".   If
       the  secret starts with an `@', what follows is assumed to
       be the name of a file from which to read  the  secret.   A
       "*"  as  the client or server name matches any name.  When
       selecting a secret, pppd takes the best match,  i.e.   the
       match with the fewest wildcards.

       Thus  a  secrets  file  contains  both  secrets for use in
       authenticating other hosts, plus secrets which we use  for
       authenticating  ourselves  to others.  Which secret to use
       is chosen based on the  names  of  the  host  (the  `local
       name')  and  its peer (the `remote name').  The local name
       is set as follows:

       if the usehostname option is given,
          then the local name is the  hostname  of  this  machine
          (with the domain appended, if given)

       else if the name option is given,
          then use the argument of the first name option seen

       else if the local IP address is specified with a hostname,
          then use that name

       else use the hostname of this machine (with the domain
          appended, if given)

       When authenticating ourselves using PAP, there is  also  a
       `username'  which is the local name by default, but can be
       set with the user option or the +ua option.

       The remote name is set as follows:




                                                               12





PPPD(8)                                                   PPPD(8)


       if the remotename option is given,
          then use the argument of  the  last  remotename  option
          seen

       else if the remote IP address is specified with a host-
          name,
          then use that host name

       else the remote name is the null string "".

       Secrets are selected from the PAP secrets file as follows:

       * For  authenticating  the  peer,  look  for a secret with
         client == username specified in  the  PAP  authenticate-
         request, and server == local name.

       * For  authenticating  ourselves  to  the peer, look for a
         secret with client == our  username,  server  ==  remote
         name.

       When  authenticating  the  peer  with  PAP, a secret of ""
       matches any password supplied by the peer.  If  the  pass-
       word  doesn't  match the secret, the password is encrypted
       using crypt() and checked against the secret  again;  thus
       secrets  for  authenticating  the  peer  can  be stored in
       encrypted form.  If the  papcrypt  option  is  given,  the
       first  (unencrypted)  comparison  is  omitted,  for better
       security.

       If the login option was specified, the username and  pass-
       word   are   also  checked  against  the  system  password
       database.  Thus, the system administrator can set  up  the
       pap-secrets  file  to  allow  PPP  access  only to certain
       users, and to restrict the set of IP addresses  that  each
       user can use.  Typically, when using the login option, the
       secret in /etc/ppp/pap-secrets would be "", to  avoid  the
       need to have the same secret in two places.

       Secrets  are  selected  from the CHAP secrets file as fol-
       lows:

       * For authenticating the peer,  look  for  a  secret  with
         client  ==  name specified in the CHAP-Response message,
         and server == local name.

       * For authenticating ourselves to the  peer,  look  for  a
         secret  with  client  ==  local name, and server == name
         specified in the CHAP-Challenge message.

       Authentication must  be  satisfactorily  completed  before
       IPCP  (or  any  other  Network  Control  Protocol)  can be
       started.  If authentication fails,  pppd  will  terminated
       the  link  (by  closing LCP).  If IPCP negotiates an unac-
       ceptable IP address for the  remote  host,  IPCP  will  be



                                                               13





PPPD(8)                                                   PPPD(8)


       closed.  IP packets can only be sent or received when IPCP
       is open.

       In some cases it is desirable to allow  some  hosts  which
       can't  authenticate themselves to connect and use one of a
       restricted set of IP addresses, even when the  local  host
       generally requires authentication.  If the peer refuses to
       authenticate itself when requested,  pppd  takes  that  as
       equivalent  to  authenticating  with  PAP  using the empty
       string for the username and password.  Thus, by  adding  a
       line  to  the  pap-secrets  file which specifies the empty
       string for the client and  password,  it  is  possible  to
       allow restricted access to hosts which refuse to authenti-
       cate themselves.

ROUTING
       When IPCP negotiation is completed successfully, pppd will
       inform the kernel of the local and remote IP addresses for
       the ppp interface.  This is sufficient to  create  a  host
       route to the remote end of the link, which will enable the
       peers to exchange IP packets.   Communication  with  other
       machines  generally requires further modification to rout-
       ing  tables  and/or  ARP  (Address  Resolution   Protocol)
       tables.   In  some  cases  this will be done automatically
       through the actions of the routed or gated daemons, but in
       most cases some further intervention is required.

       Sometimes  it  is desirable to add a default route through
       the remote host, as in the case of a  machine  whose  only
       connection  to  the Internet is through the ppp interface.
       The defaultroute option  causes  pppd  to  create  such  a
       default  route  when IPCP comes up, and delete it when the
       link is terminated.

       In some cases it is desirable to use proxy ARP, for  exam-
       ple  on  a  server machine connected to a LAN, in order to
       allow other hosts to communicate  with  the  remote  host.
       The  proxyarp  option  causes  pppd  to look for a network
       interface on the same subnet as the remote host (an inter-
       face  supporting  broadcast and ARP, which is up and not a
       point-to-point or loopback  interface).   If  found,  pppd
       creates  a  permanent,  published  ARP  entry  with the IP
       address of the remote host and the hardware address of the
       network interface found.

EXAMPLES
       In  the simplest case, you can connect the serial ports of
       two machines and issue a command like

              pppd /dev/ttya 9600 passive

       to each machine, assuming there is no getty running on the
       serial ports.  If one machine has a getty running, you can
       use kermit or tip on the other machine to log  in  to  the



                                                               14





PPPD(8)                                                   PPPD(8)


       first machine and issue a command like

              pppd passive

       Then exit from the communications program (making sure the
       connection isn't dropped), and issue a command like

              pppd /dev/ttya 9600

       The process of logging in to the other machine and  start-
       ing  pppd  can be automated by using the connect option to
       run chat, for example:

              pppd /dev/ttya 38400 connect 'chat ""  ""  "login:"
              "username"  "Password:"  "password" "% " "exec pppd
              passive"'

       (Note however that running chat like this will  leave  the
       password  visible in the parameter list of pppd and chat.)

       If your serial connection is any more complicated  than  a
       piece  of  wire,  you may need to arrange for some control
       characters to be escaped.  In particular, it is often use-
       ful  to  escape  XON  (^Q)  and  XOFF (^S), using asyncmap
       a0000.  If the path includes a telnet, you probably should
       escape  ^]  as  well  (asyncmap  200a0000).   If  the path
       includes an rlogin, you will need to  use  the  escape  ff
       option  on  the  end  which  is running the rlogin client,
       since many rlogin  implementations  are  not  transparent;
       they  will  remove  the  sequence [0xff, 0xff, 0x73, 0x73,
       followed by any 8 bytes] from the stream.

DIAGNOSTICS
       Messages are sent to  the  syslog  daemon  using  facility
       LOG DAEMON.   (This  can  be overriden by recompiling pppd
       with the macro LOG PPP defined as the  desired  facility.)
       In  order  to  see  the error and debug messages, you will
       need to edit your /etc/syslog.conf file to direct the mes-
       sages to the desired output device or file.

       The  debug option causes the contents of all control pack-
       ets sent or received to be logged, that is, all LCP,  PAP,
       CHAP or IPCP packets.  This can be useful if the PPP nego-
       tiation does not succeed.  If debugging is enabled at com-
       pile  time,  the  debug option also causes other debugging
       messages to be logged.

       Debugging can also be enabled or  disabled  by  sending  a
       SIGUSR1  to  the pppd process.  This signal acts as a tog-
       gle.

FILES
       /var/run/pppn.pid (BSD or Linux), /etc/ppp/pppn.pid (oth-
              ers)



                                                               15





PPPD(8)                                                   PPPD(8)


              Process-ID  for  pppd process on ppp interface unit
              n.

       /etc/ppp/ip-up
              A program or script which is executed when the link
              is  available  for sending and receiving IP packets
              (that is, IPCP has come up).  It is  executed  with
              the parameters

              interface-name  tty-device  speed  local-IP-address
              remote-IP-address

              and with  its  standard  input,  output  and  error
              streams redirected to /dev/null.

              This  program  or  script is executed with the same
              real and effective user-ID as  pppd,  that  is,  at
              least  the  effective user-ID and possibly the real
              user-ID will be root.  This is so that  it  can  be
              used  to  manipulate routes, run privileged daemons
              (e.g.  sendmail), etc.  Be careful  that  the  con-
              tents  of  the  /etc/ppp/ip-up and /etc/ppp/ip-down
              scripts do not compromise your system's security.

       /etc/ppp/ip-down
              A program or script which is executed when the link
              is no longer available for sending and receiving IP
              packets.  This script can be used for  undoing  the
              effects   of  the  /etc/ppp/ip-up  script.   It  is
              invoked with  the  same  parameters  as  the  ip-up
              script, and the same security considerations apply,
              since it is executed with the  same  effective  and
              real user-IDs as pppd.

       /etc/ppp/ipx-up
              A program or script which is executed when the link
              is available for sending and receiving IPX  packets
              (that  is, IPXCP has come up).  It is executed with
              the parameters

              interface-name  tty-device   speed   network-number
              local-IPX-node-address      remote-IPX-node-address
              local-IPX-routing-protocol      remote-IPX-routing-
              protocol  local-IPX-router-name  remote-IPX-router-
              name ipparam pppd-pid

              and with  its  standard  input,  output  and  error
              streams redirected to /dev/null.

              The   local-IPX-routing-protocol   and  remote-IPX-
              routing-protocol field may be one of the following:

              NONE      to indicate that there is no routing pro-
              tocol



                                                               16





PPPD(8)                                                   PPPD(8)


              RIP       to indicate that RIP/SAP should be used
              NLSP      to indicate that Novell  NLSP  should  be
              used
              RIP  NLSP   to  indicate that both RIP/SAP and NLSP
              should be used

              This program or script is executed  with  the  same
              real  and  effective  user-ID  as pppd, that is, at
              least the effective user-ID and possibly  the  real
              user-ID  will  be  root.  This is so that it can be
              used to manipulate routes, run  privileged  daemons
              (e.g.  ripd), etc.  Be careful that the contents of
              the /etc/ppp/ipx-up and  /etc/ppp/ipx-down  scripts
              do not compromise your system's security.

       /etc/ppp/ipx-down
              A program or script which is executed when the link
              is no longer available for  sending  and  receiving
              IPX  packets.   This script can be used for undoing
              the effects of the /etc/ppp/ipx-up script.   It  is
              invoked  with  the  same  parameters  as the ipx-up
              script, and the same security considerations apply,
              since  it  is  executed with the same effective and
              real user-IDs as pppd.

       /etc/ppp/pap-secrets
              Usernames,  passwords  and  IP  addresses  for  PAP
              authentication.

       /etc/ppp/chap-secrets
              Names,  secrets and IP addresses for CHAP authenti-
              cation.

       /etc/ppp/options
              System default options for pppd, read  before  user
              default options or command-line options.

       ~/.ppprc
              User  default  options,  read  before  command-line
              options.

       /etc/ppp/options.ttyname
              System default options for the  serial  port  being
              used, read after command-line options.

SEE ALSO
       RFC1144
              Jacobson,  V.   Compressing TCP/IP headers for low-
              speed serial links.  1990 February.

       RFC1321
              Rivest, R.  The MD5 Message-Digest Algorithm.  1992
              April.




                                                               17





PPPD(8)                                                   PPPD(8)


       RFC1332
              McGregor,  G.  PPP Internet Protocol Control Proto-
              col (IPCP).  1992 May.

       RFC1334
              Lloyd, B.; Simpson, W.A.  PPP authentication proto-
              cols.  1992 October.

       RFC1548
              Simpson,  W.A.   The Point-to-Point Protocol (PPP).
              1993 December.

       RFC1549
              Simpson, W.A.  PPP in HDLC Framing.  1993 December

NOTES
       The following signals have the specified effect when  sent
       to the pppd process.

       SIGINT, SIGTERM
              These  signals cause pppd to terminate the link (by
              closing LCP), restore the serial  device  settings,
              and exit.

       SIGHUP This  signal  causes  pppd  to  terminate the link,
              restore the serial device settings, and  close  the
              serial  device.   If  the  persist  option has been
              specified, pppd  will  try  to  reopen  the  serial
              device  and  start  another  connection.  Otherwise
              pppd will exit.

       SIGUSR2
              This signal causes pppd to renegotiate compression.
              This  can  be useful to re-enable compression after
              it has been disabled as a result of a fatal  decom-
              pression  error.   With  the  BSD  Compress scheme,
              fatal decompression errors generally indicate a bug
              in one or other implementation.


AUTHORS
       Drew  Perkins, Brad Clements, Karl Fox, Greg Christy, Brad
       Parker, Paul Mackerras (paulus@cs.anu.edu.au).














                                                               18


